"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const nativeTypesConfig_1 = require("./nativeTypesConfig");
const NativeDragSource_1 = require("./NativeDragSource");
function createNativeDragSource(type) {
    return new NativeDragSource_1.NativeDragSource(nativeTypesConfig_1.nativeTypesConfig[type]);
}
exports.createNativeDragSource = createNativeDragSource;
function matchNativeItemType(dataTransfer) {
    if (!dataTransfer) {
        return null;
    }
    const dataTransferTypes = Array.prototype.slice.call(dataTransfer.types || []);
    return (Object.keys(nativeTypesConfig_1.nativeTypesConfig).filter(nativeItemType => {
        const { matchesTypes } = nativeTypesConfig_1.nativeTypesConfig[nativeItemType];
        return matchesTypes.some(t => dataTransferTypes.indexOf(t) > -1);
    })[0] || null);
}
exports.matchNativeItemType = matchNativeItemType;
