"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const NativeTypes = require("../NativeTypes");
const getDataFromDataTransfer_1 = require("./getDataFromDataTransfer");
exports.nativeTypesConfig = {
    [NativeTypes.FILE]: {
        exposeProperties: {
            files: (dataTransfer) => Array.prototype.slice.call(dataTransfer.files),
            items: (dataTransfer) => dataTransfer.items,
        },
        matchesTypes: ['Files'],
    },
    [NativeTypes.URL]: {
        exposeProperties: {
            urls: (dataTransfer, matchesTypes) => getDataFromDataTransfer_1.getDataFromDataTransfer(dataTransfer, matchesTypes, '').split('\n'),
        },
        matchesTypes: ['Url', 'text/uri-list'],
    },
    [NativeTypes.TEXT]: {
        exposeProperties: {
            text: (dataTransfer, matchesTypes) => getDataFromDataTransfer_1.getDataFromDataTransfer(dataTransfer, matchesTypes, ''),
        },
        matchesTypes: ['Text', 'text/plain'],
    },
};
